/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package basicbattlesimulator;

/**
 *
 * @author William Matheson
 */
public class BattleController {
    
    private int playerClassType;
    private int playerWeaponType;
    private int playerBodyArmourType;
    private String playerName;
    
    private Character playerCharacter;
    private Weapon playerWeapon;
    private BodyArmour playerBodyArmour;
    private Chimera enemyCharacter = new Chimera();
    
    protected static String battleUpdate = "";
    protected int playerHPMonitor = 0;
    protected int enemyHPMonitor = enemyCharacter.healthPoints;
    protected static boolean battleComplete = false;
    
    Thread playerAttacks = new Thread();
    Thread enemyAttacks = new Thread();
    
    BattleController (int playerSelected, int weaponSelected, int bodyArmourSelected, String playerNameIn){
        
        playerClassType = playerSelected;
        playerWeaponType = weaponSelected;
        playerBodyArmourType = bodyArmourSelected;
        playerName = playerNameIn;
        battle();
    }
    
    private void battle(){
        
    
        switch (playerWeaponType)
        {
            case 1:  playerWeapon = new PointedStick();
                     break;
            case 2:  playerWeapon = new SteelSword();
                     break;
            case 3:  playerWeapon = new CarbonSword();
                     break;
            case 4:  playerWeapon = new DamascusSword();
                     break;
            default: playerWeapon = new SteelSword();
                     break;
        }
        
        switch (playerBodyArmourType)
        {
            case 1:  playerBodyArmour = new PeasantClothes();
                     break;
            case 2:  playerBodyArmour = new SteelArmour();
                     break;
            case 3:  playerBodyArmour = new CarbonArmour();
                     break;
            case 4:  playerBodyArmour = new ShieldGenerator();
                     break;
            default: playerBodyArmour = new SteelArmour();
                     break;
        }
        
        switch (playerClassType)
            {
            case 1:  playerCharacter = new Peasant(playerName, playerWeapon, playerBodyArmour);
                     break;
            case 2:  playerCharacter = new Knight(playerName, playerWeapon, playerBodyArmour);;
                     break;
            case 3:  playerCharacter = new GreekHero(playerName, playerWeapon, playerBodyArmour);;
                     break;
            default: playerCharacter = new Knight(playerName, playerWeapon, playerBodyArmour);;
                     break;
        }
            
        
        //have to restate these so new battles can be performed
        battleComplete = false;
        battleUpdate = "";
        playerCharacter.healthPoints = playerCharacter.healthPointMax;
        enemyCharacter.healthPoints = enemyCharacter.healthPointMax;
        
        //conduct battle threads - attacker, defender, and a wait time in ms
        playerHPMonitor = playerCharacter.healthPoints; //I didn't end up using this
        playerAttacks = new Thread(new FightThread(playerCharacter, enemyCharacter, 0));
        enemyAttacks = new Thread(new FightThread(enemyCharacter, playerCharacter, 500));
        playerAttacks.start();
        enemyAttacks.start();
        Thread Killer = new Thread();
        
        //kill threads when the time is right
        
//        while (playerHPMonitor > 0 && enemyHPMonitor > 0)
//        {
//          // wait
//        }
//        battleComplete = true;
}
    
     class Killer extends Thread
     {  
         public void run()
         {  
             while(!battleComplete)
             {
                 //waaaait

                 }
             
            if (battleComplete){
                   playerAttacks.stop();
                   enemyAttacks.stop();
                 }        
             
         }  
     }        
    
}


